%% Skript zur Aufgabe 3, Blatt 2

% Dieses Skript dient als Interface zur Funktion aufg02error. Im Grunde geht es darum, 
% sich Fehler(schranken) von Interpolationspolynomen respektive Splines zu
% veranschaulichen und  zu sehen, inwiefern der numerische Fehler der
% Polynominterpolation bei einer Interpolation mit vielen Knotenpunkten erheblich 
% ber den theoretischen  Schranken liegen kann.

% wir schlieen erstmal alle offenen figures
close all
% und lschen alle Variablen
clear variables

% Funtion, welche interpoliert werden soll
func=@exptestfunc;
% Abschtzung fr die Lipschitzkonstante zur dritten Ableitung von func
% Diese wird fr die Fehlerabschtzung mittels
% Splineinterpolation bentigt (s. Ungleichung 2.26 im Skript)
funcLip=@exptestLipschConst;
% Schtzung fr die Inf-Norm der n+1-ten Ableitung von
% func auf intval. Diese wird fr die Fehlerabschtzung
% der Polynominterpolation bentigt (s. Ungleichung (2.11) im Skript)
funcAblnp1=@exptestMaxAbsAblnp1;

fehlerkurvenplotten=1; % <--- Hier entscheidet man sich, ob man lieber die
                       % Fehlerkurven der einzelnen Interpolationen sehen
                       % mchte, i.e., fehlerkurvenplotten=1 oder doch
                       % eher Schtzungen der theoretischen Fehlerschranken
                       % im Vergleich zu den echten numerischen Fehlern,
                       % i.e., fehlerkurvenplotten=0.
if fehlerkurvenplotten
    % Hier kann man sich den absoulten Fehler der Interpolationspolynome
    % respektive der Splines fr das Intervall intval mit n Subintervallen
    % anschauen. Die Bezeichnungen 'quidistant', 'Linksshift' und
    % 'Rechtsshift' beziehen sich auf die Form der Subintervalle (siehe
    % hierzu den Abschnitt "Vorbereitungen" in aufg02error.m
    
    intval=[0,1]; % <--- Hier drfen Sie das Intervall whlen
    n=40; % <--- Hier drfen Sie die Anzahl an Subintervallen festlegen
    
    % Aufruf der eigentlichen 'Arbeiter'-Funktion. Beschreibung ber die
    % Funktionsweise siehe Kommentar in aufg02error.m
    aufg02error(intval,n,func,funcLip,funcAblnp1,fehlerkurvenplotten)
else
    % Hier werden fr eine Anzahl von ns - gegeben in nseries - die
    % Interpolationen ausgewertet und die theoretischen Fehlerschranken aus dem Skript
    % abgeschtzt und gegen die numerischen betragsmaximalen Fehler
    % geplottet. Details siehe Kommentar in aufg02error.m
    
    nseries=[5,10,20,40,60]; % <--- Hier drfen Sie die ns whlen (aufsteigend sortiert)
    nl=length(nseries);
    intval=[0,1]; % <--- Hier drfen Sie das Intervall whlen
    errboundpolyMat=zeros(nl,3); errboundsplinesMat=zeros(nl,3);
    errNumPolyMat=zeros(nl,3); errNumNewtMat=zeros(nl,3); errNumSplinesMat=zeros(nl,3);
    for i=1:nl
        [errboundpoly,errboundsplines,errNumPoly,errNumNewt,errNumSplines]=...
            aufg02error(intval,nseries(i),func,funcLip,funcAblnp1,fehlerkurvenplotten);
        
        errboundpolyMat(i,:)=errboundpoly;
        errboundsplinesMat(i,:)=errboundsplines;
        errNumPolyMat(i,:)=errNumPoly;
        errNumNewtMat(i,:)=errNumNewt;
        errNumSplinesMat(i,:)=errNumSplines;
    end
    % plotten der Fehler(-schranken) ber n
    % schwarze Symbole: Schtzungen fr die theoretischen Fehlerschranken
    % blaue Symbole: numerischer Fehler
    % x: quidistante Knoten, square: nach links verschoben, Dreieck: nach rechts
    % verschoben
    symbs='xs^';
    beschriftungen={{'quidistant'},{'Linksshift'},{'Rechtsshift'}};
    verfahren={{'polyfit'},{'Newton'},{'Spline(3,2)'}};
    for i=1:3
        subplot(3,1,1), semilogy(nseries,errboundpolyMat(:,i),strcat('k',symbs(i))), title(verfahren{1})
        hold on
        subplot(3,1,1), semilogy(nseries,errNumPolyMat(:,i),strcat('b',symbs(i)))
        subplot(3,1,2), semilogy(nseries,errboundpolyMat(:,i),strcat('k',symbs(i))), title(verfahren{2})
        hold on
        subplot(3,1,2), semilogy(nseries,errNumNewtMat(:,i),strcat('b',symbs(i)))
        subplot(3,1,3), semilogy(nseries,errboundsplinesMat(:,i),strcat('k',symbs(i))), title(verfahren{3})
        hold on
        subplot(3,1,3), semilogy(nseries,errNumSplinesMat(:,i),strcat('b',symbs(i)))
    end
end